Subject: Re: [PATCH 1/4 net-next] net: allow skb->head to be a page fragment

From: Li Yu <[email-masked]>
Date: Wed, 07 Nov 2012 16:35:21 +0800

于 2012年11月07日 16:20, Li Yu 写道:
> 于 2012年04月27日 18:33, Eric Dumazet 写道:
>> From: Eric Dumazet <[email-masked]>
>>
>> skb->head is currently allocated from kmalloc(). This is convenient but
>> has the drawback the data cannot be converted to a page fragment if
>> needed.
>>
>
> Hi, Eric,
>
> I have a question about this patch, why data are allocated from
> kmalloc() can not be converted to page fragment ? We have its kernel
> mapped address and length, so we can get its page and offset in the
> page. If the skb is not cloned (shared with others), such page and its
> offset should be can use safely, in my words.
>
> I suspected that I may lost important something in slab internals, is
> right?
>
> Thanks
>
> Yu
>

Or since slab allocated object may be across multiple pages?
I saw __netdev_alloc_skb() only use build_skb() with non-zero
fragsz if it is less than PAGE_SIZE.

Thanks

Yu

[snip]